package com.winhc.bigdata.task.configuration;

import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.IAcsClient;
import com.aliyuncs.profile.DefaultProfile;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Author: XuJiakai
 * @Date: 2020/6/8 15:41
 * @Description:
 */
@Configuration
@Data
@Slf4j
@AllArgsConstructor
public class DataWorksProjectConfiguration {
    private final DataWorksAccessProperties dataWorksAccessProperties;

    @SneakyThrows
    @Bean
    public IAcsClient client() {
        DefaultProfile.addEndpoint(
                "winhc-eci",
                dataWorksAccessProperties.getRegionId(),
                "dataworks-public",
                "dataworks." + dataWorksAccessProperties.getRegionId() + ".aliyuncs.com");
        DefaultProfile profile = DefaultProfile.getProfile(dataWorksAccessProperties.getRegionId(), dataWorksAccessProperties.getAccessKeyId(), dataWorksAccessProperties.getAccessKeySecret());
        IAcsClient client = new DefaultAcsClient(profile);
        return client;
    }
}
