package com.winhc.bigdata.task.configuration;

import com.winhc.bigdata.task.util.DataWorksParamUtils;
import com.winhc.bigdata.task.vo.dataworks.DataWorksFlowJob;
import com.winhc.bigdata.task.vo.dataworks.DataWorksFlowTask;
import lombok.Getter;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanFactoryPostProcessor;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;
import org.springframework.context.annotation.Configuration;

import java.util.List;

/**
 * @author: XuJiakai
 * 2021/4/14 14:42
 */
@Getter
@Configuration
public class ProjectParamInit implements BeanFactoryPostProcessor {

    public static final String project = "winhc_ng";

    public static final String exportFlowName = "pull_data_export_data_flow";
    public static final String exportBeanName = "winhc_ng:pull_data_export_data_flow:export_data";
    public static final String generateFlowName = "pull_data_generate_data_flow";
    public static final String generateBeanName = "winhc_ng:pull_data_generate_data_flow:generate_data";

    /**
     * @param beanFactory
     * @throws BeansException
     */
    @Override
    public void postProcessBeanFactory(ConfigurableListableBeanFactory beanFactory) throws BeansException {
        DataWorksParamUtils bean = new DataWorksParamUtils();
        List<DataWorksFlowJob> jobs = bean.getJobs();
        for (DataWorksFlowJob job : jobs) {
            String project = job.getProject();
            String flow = job.getFlow();
            List<DataWorksFlowTask> task = job.getTask();
            for (DataWorksFlowTask dataWorksFlowTask : task) {
                String beanName = project + ":" + flow + ":" + dataWorksFlowTask.getTaskName();
                beanFactory.registerSingleton(beanName, dataWorksFlowTask);
            }
        }
    }
}
