package com.winhc.bigdata.task.controller;

import cn.hutool.core.lang.Assert;
import com.winhc.bigdata.task.constant.SystemParams;
import com.winhc.bigdata.task.service.PullDataService;
import com.winhc.bigdata.task.vo.TablePartitionInfoVO;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author: XuJiakai
 * 2021/4/12 13:42
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("call-back")
public class MaxComputeCallBackController {
    private final PullDataService pullDataService;

    @PostMapping
    public Object callBack(@RequestParam(required = false) String sign, @RequestBody List<TablePartitionInfoVO> tab) {
        Assert.isTrue(SystemParams.sign.equals(sign), "验签不通过！");
        log.info("max compute数据回调：{}", tab);
        return pullDataService.callBack(tab);
    }
}
