package com.winhc.bigdata.task.controller;

import cn.hutool.core.util.RandomUtil;
import com.winhc.bigdata.task.service.DataWorksService;
import com.winhc.bigdata.task.service.DingTalkService;
import com.winhc.bigdata.task.util.DateUtils;
import com.winhc.bigdata.task.vo.dataworks.DataWorksFlowTask;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @author: XuJiakai
 * 2021/5/24 14:37
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("operations-center")
public class OperationsCenterController {
    private final DataWorksService dataWorksService;
    private final Map<String, DataWorksFlowTask> map;
    private final DingTalkService dingTalkService;

    @PostMapping("{project}/{flow}/{task}")
    public Object touch(@PathVariable String project, @PathVariable String flow, @PathVariable String task, @RequestBody Map<String, String> m) {
        String beanName = project + ":" + flow + ":" + task;
        String yesterday = DateUtils.getYesterday();
        DataWorksFlowTask dataWorksFlowTask = map.get(beanName);
        if (!m.containsKey("target_tab_prefix")) {
            m.put("target_tab_prefix", "eci_execution_person_data");
        }
        if (!m.containsKey("ds")) {
            m.put("ds", yesterday + "-" + RandomUtil.randomString(8));
        }

        if (!m.containsKey("deleted")) {
            m.put("deleted", "0");
        }
        Long touch = dataWorksService.touch(project, flow, yesterday, dataWorksFlowTask, m);
        dingTalkService.info("触发运维中心手动业务流程：{}  dag-id：{}; request body:{}", beanName, touch,m);
        return touch;
    }

    @GetMapping("{project}/{dag-id}")
    public Object query(@PathVariable String project, @PathVariable("dag-id") Long dagId) {
        return dataWorksService.query(project, dagId);
    }
}
