package com.winhc.bigdata.task.controller;

import cn.hutool.core.lang.Assert;
import com.winhc.bigdata.task.constant.SystemParams;
import com.winhc.bigdata.task.framework.odps.service.PullRequestRecordService;
import com.winhc.bigdata.task.service.PullDataService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author: XuJiakai
 * 2021/4/12 11:49
 */
@Slf4j
@RestController
@AllArgsConstructor
@RequestMapping("pull")
public class PullDataController {
    private final PullDataService pullDataService;
    private final PullRequestRecordService pullRequestRecordService;

    @GetMapping
    public Object get(@RequestParam(required = false) String sign) {
        Assert.isTrue(SystemParams.sign.equals(sign), "验签不通过！");
        return pullDataService.pull();
    }


    @GetMapping("sql")
    public Object sql(@RequestParam(required = false) String sign, String sqlId, String pullBy) {
        Assert.isTrue(SystemParams.sign.equals(sign), "验签不通过！");
        return pullRequestRecordService.pull(sqlId, pullBy);
    }
}
