package com.winhc.bigdata.task.controller;

import com.winhc.bigdata.task.framework.odps.service.OdpsSqlInfoService;
import com.winhc.bigdata.task.framework.odps.vo.OdpsSqlInfoVO;
import com.winhc.bigdata.task.framework.odps.vo.RegisterSqlVO;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * @author: XuJiakai
 * 2021/7/6 09:42
 */
@Slf4j
@RestController
@RequestMapping("sql")
@AllArgsConstructor
public class SqlController {
    private final OdpsSqlInfoService odpsSqlInfoService;


    @PostMapping("register")
    public Object registerSql(@RequestBody RegisterSqlVO registerSqlVO) {
        return odpsSqlInfoService.registerSql(registerSqlVO);
    }


    @PostMapping("save")
    public Object save(@RequestBody OdpsSqlInfoVO body) {
        return odpsSqlInfoService.add(body);
    }

    @GetMapping
    public Object get(@RequestParam String sqlId) {
        return odpsSqlInfoService.get(sqlId);
    }
}
