package com.winhc.bigdata.task.controller;

import com.aliyun.odps.OdpsException;
import com.winhc.bigdata.task.framework.odps.ExportDataCenter;
import com.winhc.bigdata.task.framework.odps.service.PullRequestRecordService;
import com.winhc.bigdata.task.framework.odps.utils.ExecOdpsSqlUtil;
import com.winhc.bigdata.task.framework.odps.vo.MaxComputeSqlInstance;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author: XuJiakai
 * 2021/7/6 11:48
 */
@Slf4j
@RestController
@RequestMapping("test")
@AllArgsConstructor
public class TestController {

    private final PullRequestRecordService pullRequestRecordService;
    private final ExportDataCenter exportDataCenter;
    private final ExecOdpsSqlUtil execOdpsSqlUtil;

    @GetMapping("pull")
    public Object pull(String sqlId, String pullBy) {
        return pullRequestRecordService.pull(sqlId, pullBy);
    }


    @GetMapping("test-pull")
    public Object testPull() {
        exportDataCenter.pull();
        return true;
    }

    @GetMapping("test-sql")
    public Object testSql() {
        exportDataCenter.sql();
        return true;
    }

    @GetMapping("test-export")
    public Object testExport() {
        exportDataCenter.export();
        return true;
    }

    @GetMapping("instance-status")
    public Object instanceStatus(String instanceId) {
        try {
            return MaxComputeSqlInstance.of(execOdpsSqlUtil.getInstance(instanceId));
        } catch (OdpsException e) {
            log.error(e.getMessage(), e);
            return e.getMessage();
        }
    }
}
