package com.winhc.bigdata.task.dao.impl;

import com.winhc.bigdata.task.dao.CompanyIndexDao;
import lombok.AllArgsConstructor;
import lombok.SneakyThrows;
import org.elasticsearch.action.search.SearchRequest;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.springframework.stereotype.Repository;

/**
 * @author: XuJiakai
 * 2021/4/13 14:25
 */
@Repository
@AllArgsConstructor
public class CompanyIndexDaoImpl implements CompanyIndexDao {
    private static final String index = "winhc-company-v8";
    private static final String type = "company";
    private final RestHighLevelClient restHighLevelClient;

    @Override
    @SneakyThrows
    public SearchResponse search(SearchSourceBuilder searchSourceBuilder) {
        SearchRequest searchRequest = new SearchRequest()
                .indices(index)
                .types(type)
                .source(searchSourceBuilder);
        return restHighLevelClient.search(searchRequest);
    }


}
