package com.winhc.bigdata.task.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.winhc.bigdata.task.enums.TaskStatusEnum;
import com.winhc.bigdata.task.util.JsonUtils;
import lombok.Builder;
import lombok.Data;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.Date;

/**
 * max compute输出表详细信息
 *
 * @author x
 * @TableName max_compute_detail_output
 */
@Builder
@TableName(value = "max_compute_detail_output")
@Data
public class MaxComputeDetailOutput implements Serializable {
    /**
     *
     */
    @TableId
    private Long id;

    /**
     * pull data task 任务id
     */
    private String taskId;

    private Long dagId;

    /**
     * max compute table name
     */
    private String maxComputeTableName;

    /**
     * 分区名
     */
    private String partitionName;

    /**
     * 该分区数量
     */
    private Long recordCount;

    /**
     * 优先级
     */
    private Integer priorityLevel;

    /**
     * 该分区任务状态
     */
    private TaskStatusEnum partitionTaskStatus;

    /**
     *
     */
    private Date updateTime;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    @TableLogic
    private Integer deleted;

    @TableField(exist = false)
    private static final long serialVersionUID = 112L;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o == null || getClass() != o.getClass()) return false;

        MaxComputeDetailOutput that = (MaxComputeDetailOutput) o;

        return new EqualsBuilder().append(id, that.id).append(taskId, that.taskId).append(dagId, that.dagId).append(maxComputeTableName, that.maxComputeTableName).append(partitionName, that.partitionName).append(recordCount, that.recordCount).append(priorityLevel, that.priorityLevel).append(partitionTaskStatus, that.partitionTaskStatus).append(updateTime, that.updateTime).append(createTime, that.createTime).append(deleted, that.deleted).isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37).append(id).append(taskId).append(dagId).append(maxComputeTableName).append(partitionName).append(recordCount).append(priorityLevel).append(partitionTaskStatus).append(updateTime).append(createTime).append(deleted).toHashCode();
    }

    @Override
    public String toString() {
        return JsonUtils.jsonObjToString(this);
    }
}