package com.winhc.bigdata.task.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.winhc.bigdata.task.enums.TaskStatusEnum;
import com.winhc.bigdata.task.util.JsonUtils;
import lombok.Builder;
import lombok.Data;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.Date;

/**
 * null
 *
 * @author x
 * @TableName pull_data_log
 */
@TableName(value = "pull_data_log")
@Data
@Builder
public class PullDataLog implements Serializable {
    /**
     *
     */
    @TableId
    private Long id;

    /**
     *
     */
    private Date requestTime;

    /**
     *
     */
    private String pullBy;

    /**
     *
     */
    private TaskStatusEnum pullStatus;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    /**
     *
     */
    @TableLogic
    private Integer deleted;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o == null || getClass() != o.getClass()) return false;

        PullDataLog that = (PullDataLog) o;

        return new EqualsBuilder().append(id, that.id).append(requestTime, that.requestTime).append(pullBy, that.pullBy).append(pullStatus, that.pullStatus).append(createTime, that.createTime).append(updateTime, that.updateTime).append(deleted, that.deleted).isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37).append(id).append(requestTime).append(pullBy).append(pullStatus).append(createTime).append(updateTime).append(deleted).toHashCode();
    }

    @Override
    public String toString() {
        return JsonUtils.jsonObjToString(this);
    }
}