package com.winhc.bigdata.task.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.winhc.bigdata.task.enums.TaskStatusEnum;
import com.winhc.bigdata.task.util.JsonUtils;
import lombok.Builder;
import lombok.Data;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;

import java.io.Serializable;
import java.util.Date;

/**
 * 拉数据任务主表
 *
 * @author x
 * @TableName pull_data_task
 */
@TableName(value = "pull_data_task")
@Data
@Builder
public class PullDataTask implements Serializable {
    /**
     *
     */
    @TableId(type = IdType.INPUT)
    private String id;


    private Long dagId;
    /**
     *
     */
    private String maxComputeFlowName;

    /**
     *
     */
    private Date startTime;

    /**
     *
     */
    private Date endTime;

    /**
     *
     */
    private TaskStatusEnum taskStatus;

    /**
     *
     */
    private Date createTime;

    /**
     *
     */
    private Date updateTime;

    /**
     *
     */
    @TableLogic
    private Integer deleted;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o == null || getClass() != o.getClass()) return false;

        PullDataTask that = (PullDataTask) o;

        return new EqualsBuilder().append(id, that.id).append(dagId, that.dagId).append(maxComputeFlowName, that.maxComputeFlowName).append(startTime, that.startTime).append(endTime, that.endTime).append(taskStatus, that.taskStatus).append(createTime, that.createTime).append(updateTime, that.updateTime).append(deleted, that.deleted).isEquals();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder(17, 37).append(id).append(dagId).append(maxComputeFlowName).append(startTime).append(endTime).append(taskStatus).append(createTime).append(updateTime).append(deleted).toHashCode();
    }

    @Override
    public String toString() {
        return JsonUtils.jsonObjToString(this);
    }
}