package com.winhc.bigdata.task.enums;

import lombok.Getter;

import java.util.Arrays;

/**
 * @Author: XuJiakai
 * @Date: 2020/6/23 10:58
 * @Description:
 */
@Getter
@SuppressWarnings("all")
public enum DataWorksTaskFlowEnum {
    NOT_RUN(1, "未运行"),
    WAIT_TIME(2, "等待时间"),
    WAIT_RESOURCE(3, "等待资源"),
    RUNNING(4, "运行中"),
    FAILURE(5, "运行失败"),
    SUCCESS(6, "运行成功"),
    CHECKING(7, "校检中"),

    ;
    private final Integer code;
    private final String msg;

    DataWorksTaskFlowEnum(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public static DataWorksTaskFlowEnum getTaskFlowEnumByCode(Integer code) {
        return Arrays.stream(DataWorksTaskFlowEnum.values())
                .filter(taskFlowEnum -> taskFlowEnum.getCode().equals(code))
                .findFirst()
                .orElse(null);
    }

    @Override
    public String toString() {
        return msg;
    }
}
