package com.winhc.bigdata.task.framework.odps;

import com.winhc.bigdata.task.framework.odps.exception.AsyncTaskRunningException;

import java.util.Map;

/**
 * @author: XuJiakai
 * 2021/7/2 10:22
 */
public interface AsyncTaskHandle {


    /**
     * 启动任务
     *
     * @param taskId
     * @param taskId
     * @return
     * @throws AsyncTaskRunningException 存在任务正在运行中，不能重复提交
     */
    String run(String taskId,String operatorName) throws AsyncTaskRunningException;


    /**
     * 判断并更新任务是否成功
     *
     * @param instanceId
     * @return
     */
    Boolean isSuccess(String instanceId);

    /**
     * 回调，用于更新任务状态
     *
     * @param map
     * @return
     */
    default Boolean callBack(Map<String, String> map) {
        return true;
    }

}
