package com.winhc.bigdata.task.framework.odps.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.winhc.bigdata.task.enums.TaskStatusEnum;
import lombok.Builder;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @author: XuJiakai
 * 2021/7/5 15:17
 */
@Builder
@TableName(value = "odps_result_info")
@Data
public class OdpsResultInfo implements Serializable {
    @TableId(type = IdType.AUTO)
    private Long id;

    private String sqlId;

    private String instanceId;

    private String instanceType;

    private String tableName;

    private String partitionName;

    /**
     * 该分区数量
     */
    private Long recordCount;

    /**
     * 优先级，数值越小优先级越高
     */
    private Integer priorityLevel;


    /**
     * json 格式
     */
    private String detail;


    /**
     * 该分区任务状态，生成中，生成完毕，导出完毕
     */
    private TaskStatusEnum partitionTaskStatus;

    /**
     *
     */
    private Date updateTime;

    /**
     *
     */
    private Date createTime;


    @TableLogic
    private Integer deleted;

}
