package com.winhc.bigdata.task.framework.odps.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.winhc.bigdata.task.enums.TaskStatusEnum;
import lombok.Builder;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @author: XuJiakai
 * 2021/7/6 10:06
 */
@Builder
@TableName(value = "pull_request_record")
@Data
public class PullRequestRecord implements Serializable {
    @TableId(type = IdType.AUTO)
    private Long id;


    private String sqlId;


    private Long odpsResultInfoId;

    /**
     * 导出数据的实例id
     */
    private String pullInstanceId;

    /**
     * 任务状态，导出中，导出完毕，等待中
     */
    private TaskStatusEnum partitionTaskStatus;

    private String pullBy;

    /**
     *
     */
    private Date updateTime;

    /**
     *
     */
    private Date createTime;


    @TableLogic
    private Integer deleted;


}
