package com.winhc.bigdata.task.framework.odps.service;

import com.winhc.bigdata.task.framework.odps.vo.OdpsSqlInfoVO;
import com.winhc.bigdata.task.framework.odps.vo.RegisterSqlVO;

/**
 * @author: XuJiakai
 * 2021/7/5 16:18
 */
public interface OdpsSqlInfoService {


    /**
     * 为sql加锁
     *
     * @param sqlId
     * @param lockByName
     * @return false 上锁失败，已经被加过锁
     */
    Boolean lock(String sqlId, String lockByName);


    /**
     * 为sql解锁
     *
     * @param sqlId
     * @return
     */
    Boolean unlock(String sqlId);


    /**
     * 快捷注册函数
     *
     * @param registerSqlVO
     * @return
     */
    OdpsSqlInfoVO registerSql(RegisterSqlVO registerSqlVO);


    /**
     * 添加sql
     *
     * @param sql
     * @return
     */
    String add(OdpsSqlInfoVO sql);

    /**
     * get
     *
     * @param sqlId
     * @return
     */
    OdpsSqlInfoVO get(String sqlId);


    /**
     * check
     *
     * @param sqlId
     * @return
     */
    Boolean check(String sqlId);
}
