package com.winhc.bigdata.task.framework.odps.utils;

import com.aliyun.odps.Instance;
import com.aliyun.odps.Odps;
import com.aliyun.odps.OdpsException;
import com.aliyun.odps.task.SQLTask;
import com.winhc.bigdata.task.framework.odps.vo.MaxComputeSqlInstance;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @author: XuJiakai
 * 2021/7/1 15:57
 */
@Slf4j
@Component
@AllArgsConstructor
public class ExecOdpsSqlUtil {

    private final Odps odps;

    public MaxComputeSqlInstance exec(String sql) throws OdpsException {
        Instance run = SQLTask.run(odps, sql);
        return MaxComputeSqlInstance.of(run);
    }

    public Instance getInstance(String instanceId) {
        return odps.instances().get(instanceId);
    }
}
