package com.winhc.bigdata.task.framework.odps.utils;

import com.winhc.bigdata.task.service.DataWorksService;
import com.winhc.bigdata.task.service.DingTalkService;
import com.winhc.bigdata.task.util.DateUtils;
import com.winhc.bigdata.task.vo.dataworks.DataWorksFlowTask;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

/**
 * @author: XuJiakai
 * 2021/7/6 10:45
 */
@Component
@AllArgsConstructor
public class ExportFlowUtils {
    private final DataWorksService dataWorksService;
    private static final String project = "winhc_ng";
    private static final String flow = "pull_spider_task";
    private static final String task = "base";
    private final Map<String, DataWorksFlowTask> map;
    private final DingTalkService dingTalkService;
    public Long export(String ds) {
        String beanName = project + ":" + flow + ":" + task;
        String yesterday = DateUtils.getYesterday();

        DataWorksFlowTask dataWorksFlowTask = map.get(beanName);

        Map<String, String> map = new HashMap<>();
        map.put("ds", ds);
        Long touch = dataWorksService.touch(project, flow, yesterday, dataWorksFlowTask, map);
        dingTalkService.info("触发运维中心手动业务流程：{}  dag-id：{}; request body:{}", beanName, touch, map);
        return touch ;

    }

}
