package com.winhc.bigdata.task.framework.odps.vo;

import com.aliyun.odps.Instance;
import com.aliyun.odps.OdpsException;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

/**
 * @author: XuJiakai
 * 2021/7/2 10:19
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class MaxComputeSqlInstance {
    private String id;
    private String jobName;
    private Integer priority;
    private String project;
    private Date startTime;
    private Date endTime;
    private String status;
    private String userAccount;
    private Boolean successful;
    private Boolean terminated;


    public static MaxComputeSqlInstance of( Instance instance) throws OdpsException {
        String id = instance.getId();
        Date startTime = instance.getStartTime();
        Date endTime = instance.getEndTime();
        String jobName = instance.getJobName();
        String project = instance.getProject();
        String status = instance.getStatus().toString();
        String owner = instance.getOwner();
        boolean successful = instance.isSuccessful();
        boolean terminated = instance.isTerminated();
        int priority = instance.getPriority();
        MaxComputeSqlInstance sqlInstance = new MaxComputeSqlInstance(id, jobName, priority, project, startTime, endTime, status, owner, successful, terminated);
        return sqlInstance;
    }
}
