package com.winhc.bigdata.task.service.impl;

import cn.hutool.core.codec.Base64;
import com.winhc.bigdata.task.configuration.ProjectParamInit;
import com.winhc.bigdata.task.enums.DataWorksTaskFlowEnum;
import com.winhc.bigdata.task.service.CompanyIndexService;
import com.winhc.bigdata.task.service.DataWorksService;
import com.winhc.bigdata.task.util.JsonUtils;
import com.winhc.bigdata.task.vo.dataworks.DataWorksFlowTask;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.Map;
import java.util.Random;

/**
 * @author: XuJiakai
 * 2021/4/14 15:38
 */
@Slf4j
//@Service
@AllArgsConstructor
public class DataWorksServiceImplTest implements DataWorksService {
    private final CompanyIndexService companyIndexService;
    private final Map<String, DataWorksFlowTask> dataWorksFlowTaskMap;

    @Override
    public Long exportData(String dt) {
        log.info(dt);
        return 123L;
    }

    @Override
    public Long generateData(String taskId) {
        Map<String, Long> dataDistribution = companyIndexService.getDataDistribution();
        String s = JsonUtils.jsonObjToString(dataDistribution);
        HashMap<String, String> map = new HashMap<>();
        map.put("taskId", taskId);
        map.put("dataDistribution", Base64.encode(s));
        DataWorksFlowTask dataWorksFlowTask = dataWorksFlowTaskMap.get(ProjectParamInit.generateBeanName);
        log.info("{}", dataWorksFlowTask.toNodeParam(map));
        return 123L;
    }

    @Override
    public Long touch(String project, String flowName, String bizDate, DataWorksFlowTask dataWorksFlowTask, Map<String, String> otherParams) {
        Map<String, String> stringStringMap = dataWorksFlowTask.toNodeParam(bizDate, otherParams);
        log.info(flowName);
        log.info("{}", stringStringMap);
        return 123L;
    }

    @Override
    public Map<String, DataWorksTaskFlowEnum> query(String projectName, Long dagId) {
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        Map<String, DataWorksTaskFlowEnum> map = new HashMap<>();
        DataWorksTaskFlowEnum d = DataWorksTaskFlowEnum.values()[new Random().nextInt(DataWorksTaskFlowEnum.values().length)];
        map.put("abc", d);
        return map;
    }
}
