package com.winhc.bigdata.task.util;

import cn.hutool.crypto.digest.HMac;
import cn.hutool.crypto.digest.HmacAlgorithm;
import com.winhc.bigdata.task.vo.Entry;
import org.apache.tomcat.util.codec.binary.Base64;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

/**
 * @author: XuJiakai
 * 2021/4/12 14:15
 */
public class DingTalkUtils {

    public static Entry<Long, String> getSign(String dingSecret) throws UnsupportedEncodingException {
        Long timestamp = System.currentTimeMillis();
        String stringToSign = timestamp + "\n" + dingSecret;


        byte[] key = dingSecret.getBytes("UTF-8");
        HMac mac = new HMac(HmacAlgorithm.HmacSHA256, key);
        byte[] signData = mac.digest(stringToSign);

        String sign = URLEncoder.encode(new String(Base64.encodeBase64(signData)), "UTF-8");
        Entry<Long, String> entry = new Entry<>();
        entry.setKey(timestamp);
        entry.setValue(sign);
        return entry;
    }
}
