package com.winhc.bigdata.task.util.ding.talk;

import com.winhc.bigdata.task.util.JsonUtils;

import java.util.HashMap;
import java.util.Map;

/**
 * @author: XuJiakai
 * 2021/4/12 14:33
 */
public interface DingTalkInterface {

    default String at(DingTalkAt at) {
        Map<String, Object> map = this.pack();
        map.put("at", at);
        return JsonUtils.jsonObjToString(map);
    }

    default String packString() {
        return JsonUtils.jsonObjToString(this.pack());
    }

    default Map<String, Object> pack() {
        Map<String, Object> map = new HashMap<>();
        if (this instanceof DingTalkText) {
            map.put("msgtype", "text");
            map.put("text", this);
        } else if (this instanceof DingTalkMarkDown) {
            map.put("msgtype", "markdown");
            map.put("markdown", this);
        }
        return map;
    }
}
