package com.winhc.bigdata.task.util.ding.talk;

/**
 * @author: XuJiakai
 * 2021/4/12 14:54
 */
public class MarkDownBuilder {

    private StringBuilder sb = new StringBuilder();

    public MarkDownBuilder br() {
        sb.append("\n\n");
        return this;
    }

    public MarkDownBuilder titleFor1(String title) {
        sb.append("# ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor2(String title) {
        sb.append("## ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor3(String title) {
        sb.append("### ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor4(String title) {
        sb.append("#### ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor5(String title) {
        sb.append("##### ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor6(String title) {
        sb.append("###### ").append(title);
        return br();
    }


    public MarkDownBuilder titleFor1(MarkDownText title) {
        sb.append("# ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor2(MarkDownText title) {
        sb.append("## ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor3(MarkDownText title) {
        sb.append("### ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor4(MarkDownText title) {
        sb.append("#### ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor5(MarkDownText title) {
        sb.append("##### ").append(title);
        return br();
    }

    public MarkDownBuilder titleFor6(MarkDownText title) {
        sb.append("###### ").append(title);
        return br();
    }


    public MarkDownBuilder text(String text) {
        sb.append(text);
        return this;
    }

    public MarkDownBuilder text(MarkDownText text) {
        sb.append(text);
        return this;
    }

    public MarkDownBuilder img(String imgUrl) {
        sb.append("![](").append(imgUrl).append(")");
        return this;
    }

    @Override
    public String toString() {
        return sb.toString();
    }

}
