package com.winhc.bigdata.task.util.ding.talk;

import lombok.Getter;

/**
 * @author: XuJiakai
 * 2021/4/12 15:25
 */
@Getter
public class MarkDownText {
    private String text;

    @Getter
    public static enum MarkDownTextStyle {
        粗体("**"), 斜体("*"), 粗斜体("***"), 删除线("~~");
        private String value;

        MarkDownTextStyle(String value) {
            this.value = value;
        }
    }

    public MarkDownText(String text) {
        this.text = text;
    }

    public MarkDownText(String text, MarkDownTextStyle style) {
        this.text = style.getValue() + text + style.getValue();
    }

    public MarkDownText link(String url) {
        this.text = "[" + this.text + "](" + url + ")";
        return this;
    }

    @Override
    public String toString() {
        return text;
    }
}
