package com.winhc.bigdata.task.vo;

import lombok.Getter;

/**
 * @Author: XuJiakai
 * @Date: 2020/9/2 16:55
 * @Description:
 */
@Getter
public class ResponseVo<T> {
    private Boolean success;
    private String msg;
    private T data;

    public static <T> ResponseVo<T> success(T data) {
        long endTime = System.currentTimeMillis();
        ResponseVo<T> responseVo = new ResponseVo<T>();
        responseVo.success = true;
        responseVo.data = data;
        return responseVo;
    }

    public static <T> ResponseVo<T> success(T data, String msg) {
        long endTime = System.currentTimeMillis();
        ResponseVo<T> responseVo = new ResponseVo<T>();
        responseVo.success = true;
        responseVo.msg = msg;
        responseVo.data = data;
        return responseVo;
    }

    public static <T> ResponseVo<T> failure(String errorMsg) {
        long endTime = System.currentTimeMillis();
        ResponseVo<T> responseVo = new ResponseVo<T>();
        responseVo.success = false;
        responseVo.msg = errorMsg;
        return responseVo;
    }
}
