package com.winhc.bigdata.task.vo.dataworks;

import com.winhc.bigdata.task.util.JsonUtils;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

import java.util.HashMap;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author: XuJiakai
 * @Date: 2020/6/24 08:50
 * @Description:
 */
@Setter
@Getter
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class NodeParam {
    private String nodeId;
    private Map<String, String> param;

    public String toNodeParam(Map<String, String> otherParams) {
        HashMap<String, String> map = new HashMap<>(param);
        for (Map.Entry<String, String> entry : otherParams.entrySet()) {
            map.put(entry.getKey(), entry.getValue());
        }
        return map.entrySet().stream()
                .filter(e -> !e.getKey().startsWith("_"))
                .filter(e -> StringUtils.isNotEmpty(e.getValue()))
                .map(e -> e.getKey() + "=" + e.getValue())
                .collect(Collectors.joining(" "));
    }

    @Override
    public String toString() {
        return JsonUtils.jsonObjToString(this);
    }
}
